-------------------------------------------------------------------------------
-- Locals                                                                    --
-------------------------------------------------------------------------------

local L = AceLibrary("AceLocale-2.0"):new("ClosetGnomeBigWigs")

-------------------------------------------------------------------------------
-- Localization                                                              --
-------------------------------------------------------------------------------

L:RegisterTranslations("enUS", function() return {
	["BigWigs module %s enabled, equipping set %s."] = true,
} end)

-------------------------------------------------------------------------------
-- Addon declaration                                                         --
-------------------------------------------------------------------------------

ClosetGnomeBigWigs = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceDB-2.0", "AceEvent-2.0")
ClosetGnomeBigWigs:RegisterDB("ClosetGnomeBigWigsDB")
ClosetGnomeBigWigs:RegisterDefaults("profile", {
	enabled = true,
})

-------------------------------------------------------------------------------
-- Initialization                                                            --
-------------------------------------------------------------------------------

function ClosetGnomeBigWigs:OnEnable()
	if not ClosetGnome or not BigWigs then return end
	self:RegisterEvent("BigWigs_RecvSync")
end

-------------------------------------------------------------------------------
-- Events                                                                    --
-------------------------------------------------------------------------------

function ClosetGnomeBigWigs:BigWigs_RecvSync(sync, rest, nick)
	if not BigWigs or sync ~= "EnableModule" or not rest or not self.db.profile.enabled then return end

	if not BigWigs:HasModule(rest) then return end
	local m = BigWigs:GetModule(rest)
	if not m or m.zonename ~= GetRealZoneText() then return end
	if m:IsBossModule() and not BigWigs:IsModuleActive(rest) then
		local setName = string.gsub(m:ToString(), " ", "")
		if ClosetGnome:HasSet(setName) then
			self:Print(string.format(L["BigWigs module %s enabled, equipping set %s."], m:ToString(), setName))
			ClosetGnome:WearSet(setName)
		end
	end
end

